# Light Plugin

This unofficial TaleSpire plugin is for adding custom light sources to your TaleSpire
game. The custom light options are accessible from the mini radial menu under an new
Light menu. Menu includes a None option to extinguish the current light. The plugin
comes with a few sample lights but the plugin is easy to configure with your own light
options and will automaticlaly enumerate those options in the radial menu.

Provides access to ambient, point and spotlight which can be placed at an offset to
the mini and their intensity, range, color and angle (for spot light) can be set.

Added light causes object to cast shadows. Added light produced hard light limits.

![Preview](https://i.imgur.com/ieRjT5J.png)
 
## Change Log

1.0.0: Initial release

## Install

Install using R2ModMan.

## Usage

The plugin can be used out-of-the-box as soon as it is installed with the sample lights
but typically the GM will want to configure his/her own light settings appropriate for
the game.

Right click the mini to open the radial menu. Select the (new) Light menu. The sub-menu
will enumarate all of conmfigured lights and includes a None option to turn off the light.
Select one of the options to turn on the corresponding light. If a light is already on,
the light will switch to the selected type. If no light is currently on, the selected
light will be turned on. Select the None sub-menu option to turn off the light.

### Configuring Lights

The number of lights and their effect, provided by the plugin, is completely configurable.
The plugin comes with a JSON (text) file which can be opened and edited to add, modify or
remove lights. The structure for a light is as follows:

	{"name":"Ball(10')",
		"lightType":2,
		"iconName":"ball.png",
		"intensity":0.05,
		"color":"200,200,200",
		"range":3.0,
		"pos":"0,1.5,0",
		"rot":"90,0,0",
		"spotAngle":10.0
	}

Each entry for a light is separated by a comma and the whole thing is enclosed in a set of
square brackets (as per the sample JSON that comes with the plugin).

"name" is the name associated with the light and is the text that is displayed in the Light
radial sub-menu.

"lightType" determine the type of light 0=Spotlight, Directional=1, Point=2, Rectangle=3,
and Disc=4. Rectangle and Disc may not be fully supported at this time. Spotlight creates
a cone from the position point in the direction of the rotation with the angle of the cone
defined by spotAngle. Directional creates a lightbeam from the position in the direction of
the rotation. Point creates light in all direction from the position point.

"iconName" determines the name of the PNG file to be used in the radial menu for this light.

"intensity" determines how stong the light is (normally between 0 to 1).

"color" is a RGB string consisting of the red, green and blue values expressed as a value
from 0 to 255, separated by a comma.

"range" determines how far the light reaches.

"pos" is a string of x, y, z float co-ordinates, separataed by commas, indicating the position
offset from the base of the mini.

"rot" is a string of x, y, z float co-ordinates, separataed by commas, indicating the rotation
offset from the base of the mini.

"spotAngle" is a float indicating the angle of a spot light.

## Limitations

1. Currently the JSON file is a local file which, if modified, need to be distributed to all
   players in order for the light be to correctly rendered on all players' devices.
   
2. Currently there is only one JSON configruation file and thus lights created for the GM to
   use (such as Ambient lights) will appear as selection for players.
   
3. Each mini supports only one light at a time.


